Linux Advanced Routing & Traffic Control HOWTO
Prev | Chapter 15. Cookbook | Next

# 15.4. Prioritizing interactive traffic

If lots of data is coming down your link, or going up for that matter, and you are trying to do some maintenance via telnet or ssh, this may not go too well. Other packets are blocking your keystrokes. Wouldn't it be great if there were a way for your interactive packets to sneak past the bulk traffic? Linux can do this for you!

As before, we need to handle traffic going both ways. Evidently, this works best if there are Linux boxes on both ends of your link, although other UNIX's are able to do this. Consult your local Solaris/BSD guru for this.

The standard pfifo_fast scheduler has 3 different 'bands'. Traffic in band 0 is transmitted first, after which traffic in band 1 and 2 gets considered. It is vital that our interactive traffic be in band 0!

We blatantly adapt from the (soon to be obsolete) ipchains HOWTO:

There are four seldom-used bits in the IP header, called the Type of Service (TOS) bits. They effect the way packets are treated; the four bits are "Minimum Delay", "Maximum Throughput", "Maximum Reliability" and "Minimum Cost". Only one of these bits is allowed to be set. Rob van Nieuwkerk, the author of the ipchains TOS-mangling code, puts it as follows:

    Especially the "Minimum Delay" is important for me. I switch it on for
    "interactive" packets in my upstream (Linux) router. I'm
    behind a 33k6 modem link. Linux prioritizes packets in 3 queues. This
    way I get acceptable interactive performance while doing bulk
    downloads at the same time.

The most common use is to set telnet & ftp control connections to "Minimum Delay" and FTP data to "Maximum Throughput". This would be done as follows, on your upstream router:

    # iptables -A PREROUTING -t mangle -p tcp --sport telnet \
      -j TOS --set-tos Minimize-Delay
    # iptables -A PREROUTING -t mangle -p tcp --sport ftp \
      -j TOS --set-tos Minimize-Delay
    # iptables -A PREROUTING -t mangle -p tcp --sport ftp-data \
      -j TOS --set-tos Maximize-Throughput

Now, this only works for data going from your telnet foreign host to your local computer. The other way around appears to be done for you, ie, telnet, ssh & friends all set the TOS field on outgoing packets automatically.

Should you have an application that does not do this, you can always do it with netfilter. On your local box:

    # iptables -A OUTPUT -t mangle -p tcp --dport telnet \
      -j TOS --set-tos Minimize-Delay
    # iptables -A OUTPUT -t mangle -p tcp --dport ftp \
      -j TOS --set-tos Minimize-Delay
    # iptables -A OUTPUT -t mangle -p tcp --dport ftp-data \
      -j TOS --set-tos Maximize-Throughput

Prev | Home | Next
Rate limit ICMP to prevent dDoS | Up | Transparent web-caching using netfilter, iproute2, ipchains and squid